<template>
    <div class="row q-gutter-md" v-if="isLoading">
        <div class="col-12 col-md">
            <q-skeleton width="100%" height="100px" />
        </div>
        <div class="col-12 col-md">
            <q-skeleton width="100%" height="100px" />
        </div>
    </div>
    <div v-else v-for="(masterGroup, indexGroup) in groupProducts" :key="indexGroup">
        <h6 :id="`${ masterGroup[0].split(' ').join('') }`" class="q-ma-none q-mx-sm q-mt-md text-bold text-uppercase">{{ masterGroup[0] }}</h6>
        <div class="row">
            <div v-for="(group, index) in masterGroup[1]" :key="index" class="col-12 col-md-6 q-pa-none q-px-xs q-pb-sm">
                <q-item class="bg-grey-3 shadow-1" :style="{ borderRadius: $q.platform.is.desktop ? '5px' : '' }">
                    <q-item-section avatar :style="{ width: '100% !important' }">

                        <div v-if="$q.platform.is.desktop" class="row full-width">
                            <div class="col-4">
                                <q-img
                                    @error="loadDefaultProductImage(indexGroup, index)"
                                    :style="{ borderRadius: '5px' }" width="180px" height="120px" no-native-menu
                                    :src="group.src_image">
                                    <div class="absolute-bottom text-subtitle1 text-center">
                                        <h6 class="q-ma-none text-bold">{{ parseFloat(group.preco_unidade_venda).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL' }) }}</h6>
                                    </div>
                                </q-img>
                            </div>
                            <div class="col-8 q-px-sm">
                                <h6 class="q-ma-none text-bold">{{ group.descricao_geral }}</h6>
                                <p class="q-ma-none text-grey-7 ellipsis-3-lines">
                                    {{ group.observacoes }}
                                </p>
                            </div>
                        </div>


                        <div v-else class="row full-width">
                            <div class="col-3 relative-position">
                                <q-img
                                    @error="loadDefaultProductImage(indexGroup, index)"
                                    :style="{ borderRadius: '5px' }" width="70px" height="70px" no-native-menu
                                    :src="group.src_image"
                                />
                                <div class="absolute bg-white text-center" :style="{ bottom: '0px', width: '70px', borderRadius: '0px 0px 5px 5px' }">
                                    <p class="q-ma-none text-bold">{{ parseFloat(group.preco_unidade_venda).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL' }) }}</p>
                                </div>
                            </div>
                            <div class="col-9 q-pl-md">
                                <p class="q-ma-none text-bold ellipsis">{{ group.descricao_geral }}</p>
                                <p class="q-ma-none text-grey-7 ellipsis-3-lines" :style="{ fontSize: '10px' }">
                                    {{ group.observacoes }}
                                </p>
                            </div>
                        </div>
                    </q-item-section>
                </q-item>
            </div>
        </div>
    </div>
</template>

<script setup>
import { useSearchStore } from "../stories/searchStore";
import { useGroupButtons } from "../stories/groupButtons";
import { useStoreInfo } from "../stories/storeInfo";
import { ref, watch } from 'vue';
import api from '../axios/api'

const emit = defineEmits(['noData']);
const storeInfo = useStoreInfo();
const groupButtons = useGroupButtons();
const searchStore = useSearchStore();
const groupProducts = ref([]);
const originData = ref([]);
const isLoading = ref(false);
function orderDataBySubGroups (data) {
    const subGroups = []
    for(const grupo of data) {
        if(typeof subGroups[grupo.descricao_grupo] === 'undefined') {
            subGroups[grupo.descricao_grupo] = []
        }
        subGroups[grupo.descricao_grupo].push(grupo)
    }

    groupButtons.updateGroupButtons(Object.keys(subGroups))
    groupProducts.value = Object.entries(subGroups)
}
async function loadProductsGroup () {
    isLoading.value = true;
    const result = await api.get('/api/products/groups', {
        transformResponse: api.defaults.transformResponse.concat(function (data, headers) {
            Object.keys(data.data).forEach(function (index) {
                data.data[index].src_image = `https://api.flex.fsbr.com.br/uploads/${String(data.data[index].codigo_filial).padStart(5, '0')}_${String(data.data[index].codigo_produtos).padStart(10, '0')}.jpg`
            });
            return data;
        })
    }).catch(error => error).finally(() => isLoading.value = false)

    orderDataBySubGroups(result.data.data)
    originData.value = result.data.data
}
function loadDefaultProductImage (indexGroup, index) {
    groupProducts.value[indexGroup][1][index].src_image = `${import.meta.env.VITE_APP_URL}/img/default.png`
}

watch(() => storeInfo.storeInfo, (newValue) => {
    if(newValue) loadProductsGroup();
}, { deep: true, immediate: true })

watch(() => searchStore.searchTerm, (newValue) => {
    const data = originData.value.filter(item => item.descricao_geral.toLowerCase().includes(newValue))
    emit('noData', (data.length === 0))
    orderDataBySubGroups(data)
})
</script>
